<?php
/**
 * Envoi de Newsletter depuis le Back-Office Prestashop 
 * @category admin
 * @license http://www.opensource.org/licenses/osl-3.0.php Open-source licence 3.0
 * @author  Eolia  01/07/2012 compatible PS 1.3- 1.4.8.2
 * @version 2.8
 *
 */
if (!defined('_CAN_LOAD_FILES_'))
    exit;
 global $ver;
 $ver = '2.8';
class newsletteradmin extends Module
{

 
    public function __construct ()
    {
	 global $ver;
        $this->name = 'newsletteradmin';
        $this->tab = 'administration';
        $this->version = $ver;
        $this->author = 'eolia@eolia.o2switch.net';
        
        parent::__construct();

        $this->confirmUninstall = $this->l('Delete your Newsletter module ?');
        $this->displayName = $this->l('Newsletter for Prestashop');
        $this->description = $this->l('Sending newsletter from the Back-Office');
// If this module requires configuration, check whether configured and show warning, if not configured        
        if (self::isInstalled($this->name) && $this->isConfigurable())
        {
            $warning = $this->l('Module not configured correctly');
            if (!$this->_isConfigured($warning)
                && !empty($warning))
            {
                $this->warning .= $warning;
            }
        } 		
    }

	
    private function adminInstall()
	
	{
		$sql_query =("show table status ");
		$result_query=mysql_query($sql_query) or die(mysql_error());
		$result = mysql_fetch_array($result_query);	
		
	if (!defined ('_MYSQL_ENGINE_')){
		define('_MYSQL_ENGINE_',$result["Engine"]);
		}
		
		$sql_query =("
		CREATE TABLE IF NOT EXISTS `"._DB_PREFIX_."mailing_track` (
		  `ID` int(5) NOT NULL PRIMARY KEY auto_increment,
		  `ipAddress` varchar(12) NOT NULL default '',
		  `id_campaign` varchar(5) NOT NULL default '0',
		  `subject` varchar(255) NOT NULL default '0',
		  `postDate` varchar(10) NOT NULL default '',
		  `postTime` varchar(8) NOT NULL default '',
		  `email` varchar(128) NOT NULL default ''
		) ENGINE="._MYSQL_ENGINE_." DEFAULT CHARSET=utf8");
		$result_query=mysql_query($sql_query) or die(mysql_error()); 
		
		$sql_query2 =("
		CREATE TABLE IF NOT EXISTS `"._DB_PREFIX_."mailing_history` (
		  `id_campaign` int(5) NOT NULL PRIMARY KEY,
		  `subject` varchar(255) NOT NULL default '',
		  `date` varchar(10) NOT NULL ,
		  `time` varchar(8) NOT NULL,
		  `num_sent` int(8) NOT NULL
		) ENGINE="._MYSQL_ENGINE_." DEFAULT CHARSET=utf8");
		$result_query=mysql_query($sql_query2) or die(mysql_error()); 

		$sql_query3 =("
		CREATE TABLE IF NOT EXISTS `"._DB_PREFIX_."mailing_sent` (
		  `id_campaign` varchar(5) NOT NULL default '',
		  `email` varchar(128) NOT NULL default '',
		  `date` varchar(20) NOT NULL,
		  `dateReceived` varchar(20) NOT NULL,
		  INDEX (`email`)
		) ENGINE="._MYSQL_ENGINE_." DEFAULT CHARSET=utf8");
		$result_query=mysql_query($sql_query3) or die(mysql_error()); 

		$sql_query =("
		CREATE TABLE IF NOT EXISTS `"._DB_PREFIX_."mailing_import` (
			`ID` int(5) NOT NULL PRIMARY KEY auto_increment,
			`email` varchar(128) NOT NULL default '',
			`lastname` varchar(32)  default '',
			`firstname` varchar(32)  default ''
			) ENGINE="._MYSQL_ENGINE_." DEFAULT CHARSET=utf8");
			$result=mysql_query($sql_query) or die(mysql_error()); 
		
		$idVersion = Configuration::get ('Admin_Newsletter_Version');
		if (!isset($idVersion))	Configuration::updateValue('Admin_Newsletter_Version', '0.0');
			Configuration::updateValue('ADMIN_DIR', _PS_ADMIN_DIR_);
            $tab = new Tab();
            $tab->class_name = 'AdminNewsletter';
            $tab->id_parent = 2;
            $tab->module = 'newsletteradmin';
            $tab->name[(int)(Configuration::get('PS_LANG_DEFAULT'))] = $this->l('Send a newsletter');
            return $tab->add();
    }    
 
    public function install ()
    {
        
		return parent::install() && $this->adminInstall();
    }
	       
    

    public function isConfigurable ()
    {
        return (int) method_exists($this, 'getContent') ? true : false;
    }
 
    protected function _isConfigured($warning)
    {
	 global $ver;
        // Check the configuration data for this module and return false
        // if the configuration is not correct or cannot be used to render
        // this module. While returning false, set the error message to
        // the $warning parameter
        $idVersion = Configuration::get ('Admin_Newsletter_Version');
        if ($idVersion < $ver)
        {
            $warning = $this->l ('Warning: Your module is not configured!');
            return false;
        }
        return true;
    }	
	
	
 	public function getContent()
	{
		$output = '<h2>'.$this->displayName.'</h2>
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
			<fieldset>
				<legend><img src="'.$this->_path.'logo.gif" alt="" title="" />'.$this->l('Settings').'</legend>
				<label>'.$this->l('Copying Files').'<br/></label>
				<div class="margin-form">
					<br/>'.$this->l('Why copy files?').'
					<p class="clear">'.$this->l('Some files are necessary for the proper functioning of this module. Adding plugins in tiny_mce and two directories, copying files track and unsubscribe to the root of your store and add style mails. The full list will be visible to the next window.').'<br/><br/>
					'.$this->l('You can skip this step if you have already copied the files, or if you want to do it by yourself.').'</p>
				</div>
				<center>
				<input type="button" class="button" value=" '.$this->l(' Copy files ').' " onClick="javascript:document.location.href=\''._MODULE_DIR_.'newsletteradmin/install.php\'" /></center><br/><br/>
				<div class="margin-form">
				'.$this->l('Once your files are copied, you can click on the "Clients" tab and "Send a newsletter"').'
				</div>
			</fieldset>
		</form>';
		return $output;
	}
		
    public function uninstall ()
    {	$adir = Configuration::get('ADMIN_DIR');
	    $file = $adir.'/tabs/AdminNewsletter.php';
		$file1 = _PS_ROOT_DIR_.'/track.php';
		$file2 = _PS_ROOT_DIR_.'/unsubscribe.php';
		if (file_exists($file)) {
		unlink($file);}
		if (file_exists($file1)) {
		unlink($file1);}
		if (file_exists($file2)) {
		unlink($file2);}
		//mysql_query("DROP TABLE IF EXISTS `"._DB_PREFIX_."mailing_track`"); 		 
		//mysql_query("DROP TABLE IF EXISTS `"._DB_PREFIX_."mailing_history`");  
        $tab = new Tab(Tab::getIdFromClassName('AdminNewsletter'));
        return parent::uninstall()
                && $tab->delete();
    }
	
}
 
?>