<?php
/* 
 * Copie des fichiers nécessaires aux fonctionnalités du module 
 * @module newsletteradmin 
 * @copyright eolia@o2switch.net
*/
header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
header("Expires: Sat, 26 Jul 1997 05:00:00 GMT"); // Date dans le passé
include(dirname(__FILE__).'/../../config/config.inc.php');
include(dirname(__FILE__).'/functions.php');
$ver = '2.8';
$filename = 'INSTALL';

if(intval(Configuration::get('PS_REWRITING_SETTINGS')) === 1)
	$rewrited_url = __PS_BASE_URI__;
	
	clearstatcache();
	Configuration::updateValue('Admin_Newsletter_Version', $ver);
	$iso = trim(Configuration::get('PS_LOCALE_LANGUAGE'));
	if (empty($iso)){ echo'Please configure your local language before continue in Preferences/Localization and retry<br/><br/>
		<center><input type="button" class="button" value="'.trans('Back').'" onClick="javascript:history.go(-1)" /></center>';die();}
	$rep_lang = _PS_MODULE_DIR_.'newsletteradmin/lang';
	$files = 'scripts';
	$trans_lang = $rep_lang.'/lang_'.$iso.'.php';
	$uni_lang = $rep_lang.'/uni_lang.php';
	$temp_lang = $rep_lang.'temp.php';
			if ($iso != 'en') 
			{
				if (!file_exists ($trans_lang))
				{
				if (file_exists($uni_lang)) {
					copy($uni_lang,$temp_lang); 
					rename($temp_lang,$trans_lang);
					echo '<b>'.trans('A translation file for your language has been created here').':</b> '.$trans_lang.'<br/>'.trans('You can edit it later to translate the expressions in your language').'.';}
					else die('<font color="red">Error: The files uni_lang.php is missing! <br/><br/>Verify your archive in '.$rep_lang.'</font>');
				}
				else{ echo '<b>'.trans('A translation file for your language is here').':</b> '.$trans_lang.'<br/>';}
			}else{ echo 'No translations required to your language (English)<br/>';}
			
	/***  Update tiny  ***/
if (!extension_loaded('curl'))  die('Error! Curl extension is not activated on your server, please install it and retry.');
			$tiny = '../../js/tiny_mce';
			$tiny_old = '../../js/tiny_mce_old';
			if (file_exists($tiny_old)) {
				if(is_writable($tiny_old))
					{@deltree($tiny_old);}
					else echo 'This file is not erasable: '.$tiny_old;}
			if (!file_exists($tiny_old)) {
				ini_set('user_agent', $_SERVER['HTTP_USER_AGENT']);
			
					$url = 'http://www.eolia.o2switch.net/newsletter/download/tiny.zip ';
					$testUrl = fopen($url, 'r');
					if ($testUrl){
					$tempFile = 'upgrade_tiny.zip';
					
					fclose($testUrl);
					$out = fopen($tempFile , 'wb');
					$ch = curl_init();
						curl_setopt($ch, CURLOPT_FILE, $out);
						curl_setopt($ch, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
						curl_setopt($ch, CURLOPT_HEADER, false);
						curl_setopt($ch, CURLOPT_URL, $url);
						curl_exec($ch);

					$info = curl_getinfo($ch);

					if($info['http_code'] == 200 ) {
					if (file_exists($tiny)) {rename($tiny,$tiny_old);}
							include(dirname(__FILE__).'/pclzip.lib.php');
							  $archive = new PclZip($tempFile);
							  if ($archive->extract(PCLZIP_OPT_PATH, '../../js',
													PCLZIP_OPT_REMOVE_PATH, $tempFile) == 0)
													{
								die("Error : ".$archive->errorInfo(true));
							  } 
					fclose($out);
					chmod($tempFile, 0755);
					} 
					
					}else echo 'Server connection failed or files are missing! Try later or download it here: '.$url.' and copy it in your js directory';
				} 

	
    function smartCopy($source, $dest, $options=array('folderPermission'=>0755,'filePermission'=>0755)) 
    { 
        $result=false; 
        
        if (is_file($source)) { 
		echo trans('Copying file').': ';		
            if ($dest[strlen($dest)-1]=='/') { 
                if (!file_exists($dest)) { 
                    cmfcDirectory::makeAll($dest,$options['folderPermission'],true); 
                } 
                $__dest=$dest."/".basename($source); 
            } else { 
                $__dest=$dest;
		echo $__dest.'...<br/>';				
            } 
            $result=copy($source, $__dest);
			chmod($__dest,$options['filePermission']); 
        
        } elseif(is_dir($source)) { 
            if ($dest[strlen($dest)-1]=='/') { 
                if ($source[strlen($source)-1]=='/') { 
                    //Copy only contents 
                } else { 
                    //Change parent itself and its contents 
                    $dest=$dest.basename($source); 
                    @mkdir($dest); 
                    chmod($dest,$options['filePermission']); 
                } 
            } else { 
                if ($source[strlen($source)-1]=='/') { 
                    //Copy parent directory with new name and all its content 
                    @mkdir($dest,$options['folderPermission']); 
                    chmod($dest,$options['filePermission']); 
                } else { 
                    //Copy parent directory with new name and all its content 
                    @mkdir($dest,$options['folderPermission']); 
                    chmod($dest,$options['filePermission']); 
                } 
            } 

            $dirHandle=opendir($source); 
            while($file=readdir($dirHandle)) 
            { 
                if($file!="." && $file!="..") 
                { 
                     if(!is_dir($source."/".$file)) { 
                        $__dest=$dest."/".$file; 
                    } else { 
                        $__dest=$dest."/".$file; 
                    } 
                    $result=smartCopy($source."/".$file, $__dest, $options);
                } 
            } 
            closedir($dirHandle);            
        } else {$result=false; 
        } 
        return $result; 
    }
	
	
		echo '
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
		<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
		<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
		<head>
        <meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
        <title>'.trans('Update Files').'</title>
			<fieldset style="background:#FFFFF0;border:1px solid #DFD5C3;font-size:1em;margin:50px;padding:1em">
				<legend><img src="logo.gif"  alt="" title="Newsletter" /> <a style="margin: 0;padding: 0.2em 0.5em;border: 1px solid #DFD5C3;background: #FFF6D3;font-weight: bold;text-align: left;">'.trans('Copying files to your server').' </a></legend>
				<label><b>'.trans('Copying files').'...</b><br/></label>';
	

		$adir = Configuration::get('ADMIN_DIR');
		$files = 'AdminNewsletter.php';
		$file_bak= 'AdminNewsletter.php.bak';
		$iso = Configuration::get('PS_LOCALE_LANGUAGE');


		if (!file_exists($files)) @rename($file_bak,$files) or die('<font color="red">'.trans('Error: The files AdminNewsletter.php or AdminNewsletter.php.bak not exist! Verify your archive').'</font>');
		if (file_exists($files)){
			$files2 = $adir.'/tabs/AdminNewsletter.php';
			$rep = $adir.'/tabs';
			$right = substr(sprintf('%o', fileperms($rep)), -4);
			if ($right >= 700) { echo '<font color="green">'.trans('OK, you are allowed to write on the folder').': '.$rep.' --> CHMOD: '.$right.'</font><br/>';
			@smartCopy($files, $files2, $options=array('folderPermission'=>0755,'filePermission'=>0755));
			echo '<br/><b>'.trans('The file').' '.$files.' '.trans('was successfully copied to').' '.$files2.'
			<p align="center">'.trans('Finish!').'</p></b><br/>'; 
			rename($files,$file_bak);			
			}
		else {
		rename($files,$file_bak);
		echo '<b><font color="red">'.trans('Error!').' '.trans('You are not allowed to write on the folder').': '.$rep.' -> ' .$right.'. '.trans('Your chmod rights should be greater or equal to').' 700 <p align="center">'.trans('FAIL!').'</p></font></b><br/><br/>
		<center><input type="button" class="button" value="'.trans('Back').'" onClick="javascript:history.go(-1)" /></center>';
					exit(); }				
		}
		//Clean after auto-update
		if (file_exists('../newsletteradmin_old')) { 
			@deltree('../newsletteradmin_old'); 
			echo '<br/>'.trans('Old  version module successfully deleted').'!<br/><br/>';
		}
		$right = substr(sprintf('%o', fileperms($tempFile)), -4);
		if ($right <= 700)echo '<b><font color="red">'.trans('Error!').'</b></font> your chmod\'s rights are '.$right.' on '.$tempFile.' and are too restrictive, please delete this file yourself. Maybe you are on a windows server ?<br/>';
		if(unlink($tempFile)){
			echo '<br/>Update Tiny, '.trans('Downloading files and install').'... <b>'.trans('your tiny is up to date!').'</b> '; 
			echo '<b><p align="center">'.trans('Finish!').'</p></b><br/><br/>';}
		//Recovery templates	
		if (file_exists($tiny.'_old/templates')) {
			$right = substr(sprintf('%o', fileperms($tiny.'_old/templates')), -4);
			if ($right >= 700) { echo '<font color="green">'.trans('OK, you are allowed to write on the folder').': '._PS_ROOT_DIR_.'/js/tiny_mce/templates --> CHMOD: '.$right.'</font><br/>';
			unlink($tiny.'_old/templates/list.php');
			unlink($tiny.'_old/templates/supp.php');
			@smartCopy($tiny.'_old/templates', $tiny.'/templates', $options=array('folderPermission'=>0755,'filePermission'=>0755));
			echo trans('Your old templates have been saved');
			echo '<b><p align="center">'.trans('Finish!').'</p><br/>'.trans('The file').' '.$tiny.'_old/templates '.trans('was successfully copied to').' '.$tiny.'/templates</b><br/><br/>'; 
			}else {
			echo '<b><font color="red">'.trans('Error!').' '.trans('You are not allowed to write on the folder').': '._PS_ROOT_DIR_.'/js/tiny_mce/templates -> ' .$right.'. '.trans('Your chmod rights should be greater or equal to').' 700 <p align="center">'.trans('FAIL!').'</p></font></b><br/><br/>
			<center><input type="button" class="button" value="'.trans('Back').'" onClick="javascript:history.go(-1)" /></center>';
					exit(); } 
			}
		$files = 'scripts/files';
		$files2 =  _PS_ROOT_DIR_;
		if (!is_dir($files)) echo '<font color="red">'. trans('Error: The directory').' '. $files.' '.trans('not exist! Verify your archive').'</font><br/>';
			$right = substr(sprintf('%o', fileperms($files2)), -4);
			if ($right >= 700) { echo '<font color="green">'.trans('OK, you are allowed to write on the folder').': '.$files2.' --> CHMOD: '.$right.'</font><br/>';
			smartCopy($files, $files2, $options=array('folderPermission'=>0755,'filePermission'=>0755));
			echo '<b><p align="center">'.trans('Finish!').'</p><br/>'.trans('The entire file').' '.$files.' '.trans('was successfully copied to').' '.$files2.'</b><br/><br/>'; 
			}else {
			echo '<b><font color="red">'.trans('Error!').' '.trans('You are not allowed to write on the folder').': '.$files2.' -> ' .$right.'. '.trans('Your chmod rights should be greater or equal to').' 700 <p align="center">'.trans('FAIL!').'</p></font></b><br/><br/>
			<center><input type="button" class="button" value="'.trans('Back').'" onClick="javascript:history.go(-1)" /></center>';
					exit(); } 
			
		$files = 'scripts/manage';
		$files2 =  _PS_ROOT_DIR_;
		if (!is_dir($files)) echo '<font color="red">'. trans('Error: The directory').' '. $files.' '.trans('not exist! Verify your archive').'</font><br/>';
		$right = substr(sprintf('%o', fileperms($files2)), -4);
			if ($right >= 700) { echo '<font color="green">'.trans('OK, you are allowed to write on the folder').': '.$files2.' --> CHMOD: '.$right.'</font><br/>';
			smartCopy($files, $files2, $options=array('folderPermission'=>0755,'filePermission'=>0755));
			echo '<b><p align="center">'.trans('Finish!').'</p><br/>'.trans('The entire file').' '.$files.' '.trans('was successfully copied to').' '.$files2.'</b><br/><br/>'; 
			}else {
			echo '<b><font color="red">'.trans('Error!').' '.trans('You are not allowed to write on the folder').': '.$files2.' -> ' .$right.'. '.trans('Your chmod rights should be greater or equal to').' 700 <p align="center">'.trans('FAIL!').'</p></font></b><br/><br/>
			<center><input type="button" class="button" value="'.trans('Back').'" onClick="javascript:history.go(-1)" /></center>';
					exit(); } 
			
		$files = 'modules';
		$files2 =  _PS_ROOT_DIR_.'/modules';
		if (!is_dir($files)) echo '<font color="red">'. trans('Error: The directory').' '. $files.' '.trans('not exist! Verify your archive').'</font><br/>';
		$right = substr(sprintf('%o', fileperms($files2)), -4);
			if ($right >= 700) { echo '<font color="green">'.trans('OK, you are allowed to write on the folder').': '.$files2.' --> CHMOD: '.$right.'</font><br/>';
			smartCopy($files, $files2, $options=array('folderPermission'=>0755,'filePermission'=>0755));
			echo '<b><p align="center">'.trans('Finish!').'</p><br/>'.trans('The entire file').' '.$files.' '.trans('was successfully copied to').' '.$files2.'</b><br/><br/>'; 
			}else {
			echo '<b><font color="red">'.trans('Error!').' '.trans('You are not allowed to write on the folder').': '.$files2.' -> ' .$right.'. '.trans('Your chmod rights should be greater or equal to').' 700 <p align="center">'.trans('FAIL!').'</p></font></b><br/><br/>
			<center><input type="button" class="button" value="'.trans('Back').'" onClick="javascript:history.go(-1)" /></center>';
					exit(); }
		echo  '
			</fieldset>';
			
	if (file_exists ('translate_admin_'.$iso.'.txt')){

		$fr = dirname(__FILE__).'/../../translations/'.$iso.'/admin.php';	
		$win = file_get_contents($fr);
		$test= preg_replace("/\?>/", '', $win);
		$r = chr(13);
		$wadd = file_get_contents('translate_admin_'.$iso.'.txt').$r.'?>'; 
		$test .= $wadd;
		file_put_contents($fr,$test);	
			
	}
	

		if (isset($_SERVER['HTTP_REFERER'])) {

			echo'
			<a href="'.$_SERVER['HTTP_REFERER'].'">
				<center><button> '.trans('Back').'</button></a></center>';
				}
			else{
			echo '<center><input type="button" class="button" value="'.trans('Back').'" onClick="javascript:history.go(-1)" />';}
	echo '		</fieldset>
				</form>';

?>